//Variáveis de entrada e saída **********************************************************************
long Value = 0;                 //Valor da leitura atual (Entrada)
long Filtered = 0;              //Resposta do valor filtrado (Saída)
//Variáveis de setup*********************************************************************************
unsigned long Interval = 100;   //Intervalo de cálculo para atenuação de ruídos em ms
int Tolerance = 5;              //Tolerância dos picos de sinal em %
int Discard = 4;                //Número máximo de descarte sequêncial de leituras fora da tolerância
#define Samples 20              //Número de amostras para a média móvel
//Variáveis de controle******************************************************************************
unsigned long Timer_Old = 0;    //Valor de controle do temporizador
int Discarted = 0;              //Contador de leituras descartadas por estar fora da tolerância
long Readings[Samples];         //Array das amostras para a média móvel
long Sum = 0;                   //Variável que armazena a soma das leituras

void Analog_Filter(){
  //Verificação do intervalo de tempo entre cada leitura
  if ((millis() > (Timer_Old + Interval)) || (Timer_Old > millis())){
    //Verificação se o valor lido está dentro da tolerância
    if (((Value > (Filtered + (Filtered / (100/Tolerance)))) || (Value < (Filtered - (Filtered / (100/Tolerance))))) && (Discarted < Discard)){
      Discarted++;
    }else if (((Value > (Filtered + (Filtered / (100/Tolerance)))) || (Value < (Filtered - (Filtered / (100/Tolerance))))) && (Discarted >= Discard)){
      //Executa o FIFO do array de leitura
      for (int i = 0; i < (Samples - 1); i++){
        Readings[i] = Readings[i + 1];
      }
      //Adiciona o novo valor ao array
      Readings[Samples - 1] = Value;
      Sum = 0;
      //Realiza o cálculo da média
      for (int i = 0; i < Samples; i++){
        Sum = Sum + Readings[i];
      }
      Filtered = Sum / Samples;
    }else{
      Discarted = 0;
      //Executa o FIFO do array de leitura
      for (int i = 0; i < (Samples - 1); i++){
        Readings[i] = Readings[i + 1];
      }
      //Adiciona o novo valor ao array
      Readings[Samples - 1] = Value;
      Sum = 0;
      //Realiza o cálculo da média
      for (int i = 0; i < Samples; i++){
        Sum = Sum + Readings[i];
      }
      Filtered = Sum / Samples;
    }
    Timer_Old = millis(); 
  }

}
