//Exemplo para implementação de um filtro analógico com 3 camadas

//Camada 1: Intervalo de leitura
//Tem o objetivo de realizar a leitura dos valores em um intervalo de
//tempo mais próximo da variação real das medidas

//Camada 2: Retirada de picos de leitura
//Tem o objetivo de rejeitar picos de leitura que possam aparecer
//devido a ruídos externos no sistema

//Camada 3: Média móvel
//Tem o objetivo de suavizar a variação da leitura da entrada analógica
//evitando bruscos movimentos e facilitando a ação do controle

//Definição do pino analógico
#define pin_AI1 35

//Inclusão da função do filtro
#include "Analog_Filter.h"

void setup() {
  //Inicializa serial
  Serial.begin(115200);
  //Inicializa array de leitura
  //Essa inicialização não é mandatória, mas entrega para o controle
  //um valor inicial diferente de zero. Caso contrário a variável demoraria 
  //alguns ciclos de máquina para atingir o valor atual.
  for (int i = 0; i < Samples; i++){
    Readings[i] = analogRead(pin_AI1);
    Serial.print(i);
    Serial.print(" / ");
    Serial.println(Readings[i]);
  }
}

void loop() {

  //Leitura do valor analógico
  Value = analogRead(pin_AI1);
  //Chamada da função de filtro
  Analog_Filter();
  //Serial debug
  Serial.print(Value);
  Serial.print(" / ");
  Serial.println(Filtered);

}
